close all
clc
clear all

np = 1:19;

%222.9
map = [0.1, 58.8, 27.9, 15.1, 10.2, 7.2, 5.2, 4.1, 3.3, 2.7, 2.3, 2.0, 1.6, 1.4, 1.3, 1.1, 1.0, 0.9, 0.8];
graph = [75.4, 37.8, 27.0, 19.2, 15.7, 13.7, 11.5, 10.2, 8.7, 8.0, 7.5, 6.8, 6.4, 5.8, 5.4, 5.2, 5.0, 4.8, 4.5];
assembly = [140.3, 71.6, 46.1, 35.9, 28.6, 23.9, 20.0, 17.9, 15.3, 13.9, 12.6, 11.7, 10.4, 10., 9.4, 8.5, 7.7, 7.5, 7.3];

total = map+graph+assembly;

line_width = 1.5;
bar_width = 1;
figure
b1 = bar(np+0.5,map+graph+assembly,bar_width,'r','LineWidth',line_width);
hold on 
b2 = bar(np+0.5,graph+assembly,bar_width,'g','LineWidth',line_width);
b3 = bar(np+0.5,assembly,bar_width,'b','LineWidth',line_width);
xlabel('MPI process')
ylabel('Real CPU cost [sec]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,20])
legend([b1,b2,b3],'Map','Graph','Matrix')
%matlab2tikz('mpi_cube_real_CPU.tex')


figure
b1 = bar(np+0.5,(map+graph+assembly)./total,bar_width,'r','LineWidth',line_width);
hold on 
b2 = bar(np+0.5,(graph+assembly)./total,bar_width,'g','LineWidth',line_width);
b3 = bar(np+0.5,assembly./total,bar_width,'b','LineWidth',line_width);
xlabel('MPI process')
ylabel('Relative CPU cost [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,20])
legend([b1,b2,b3],'Map','Graph','Matrix', 'Location','SouthEast')
%matlab2tikz('mpi_cube_relative_CPU.tex')

% figure
% b1 = bar(np+0.5,(map+graph+assembly).*np,bar_width,'r','LineWidth',line_width);
% hold on 
% b2 = bar(np+0.5,(graph+assembly).*np,bar_width,'g','LineWidth',line_width);
% b3 = bar(np+0.5,(assembly).*np,bar_width,'b','LineWidth',line_width);
% xlabel('MPI process')
% ylabel('Used CPU cost [sec]')
% set(gca,'fontsize',18)
% grid on
% box on
% xlim([1,20])
% legend([b1,b2,b3],'Map','Graph','Matrix')
%matlab2tikz('mpi_cube_used_CPU.tex')

line_width = 2;

figure
p1 = plot(np,total(1)./total,'-bo',...
                'LineWidth',line_width,...
                'MarkerEdgeColor','b',...
                'MarkerFaceColor',[.49 1 .63],...
                'MarkerSize',10);
hold on
p2 = plot(np,np,'r--','LineWidth',line_width);
xlabel('MPI process')
ylabel('Speedup [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,19])
legend([p1,p2],'Actual','Ideal', 'Location','SouthEast')
%matlab2tikz('mpi_cube_speed_up.tex')

figure
p1 =plot(np,(total(1))./(total.*np),'-bo',...
                'LineWidth',line_width,...
                'MarkerEdgeColor','b',...
                'MarkerFaceColor',[.49 1 .63],...
                'MarkerSize',10);
hold on
p2 = plot([1,19],[1,1],'r--','LineWidth',line_width);
xlabel('MPI process')
ylabel('Efficiency [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,19])
legend([p1,p2],'Actual','Ideal', 'Location','SouthEast')
%matlab2tikz('mpi_cube_scalability.tex')

%%

figure
p1 = plot(np,assembly(1)./assembly,'-bo',...
                'LineWidth',line_width,...
                'MarkerEdgeColor','b',...
                'MarkerFaceColor',[.49 1 .63],...
                'MarkerSize',10);
hold on
p2 = plot(np,np,'r--','LineWidth',line_width);
xlabel('MPI process')
ylabel('Speedup [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,19])
legend([p1,p2],'Actual','Ideal', 'Location','SouthEast')
%matlab2tikz('mpi_cube_speed_up.tex')

figure
p1 =plot(np,(assembly(1))./(assembly.*np),'-bo',...
                'LineWidth',line_width,...
                'MarkerEdgeColor','b',...
                'MarkerFaceColor',[.49 1 .63],...
                'MarkerSize',10);
hold on
p2 = plot([1,19],[1,1],'r--','LineWidth',line_width);
xlabel('MPI process')
ylabel('Efficiency [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,19])
legend([p1,p2],'Actual','Ideal', 'Location','SouthEast')
%matlab2tikz('mpi_cube_scalability.tex')

%%

close all
clc
clear all

np = 12;

n_iter = linspace(1,200,200);

map = [0.1,2.];
graph = [75.4,6.8];
assembly = [140.3,11.7];

for i=1:length(n_iter)
    total(i,:) = map(:)+graph(:)+n_iter(i)*assembly(:);
end

line_width = 2;

figure
p1 = plot(n_iter,total(:,1)./total(:,2),'-b',...
                'LineWidth',line_width);
hold on
p2 = plot([1,max(n_iter)],[np,np],'r--','LineWidth',line_width);
p3 = plot([1,max(n_iter)],[assembly(1)/assembly(2),assembly(1)/assembly(2)],'g--','LineWidth',line_width);
xlabel('Number of linear iterations')
ylabel('Speedup [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,max(n_iter)])
ylim([10,12])
legend([p1,p2,p3],'Actual','Ideal','Theoretical limit', 'Location','SouthEast')
matlab2tikz('cube_linear_speed_mpi.tex')

figure
p1 =plot(n_iter,total(:,1)./(total(:,2)*np),'-b',...
                'LineWidth',line_width);
hold on
p2 = plot([1,max(n_iter)],[1,1],'r--','LineWidth',line_width);
p3 = plot([1,max(n_iter)],[assembly(1)/(np*assembly(2)),assembly(1)/(np*assembly(2))],'g--','LineWidth',line_width);
xlabel('Number of linear iterations')
ylabel('Efficiency [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,max(n_iter)])
ylim([0.8,1])
legend([p1,p2,p3],'Actual','Ideal','Theoretical limit', 'Location','SouthEast')
matlab2tikz('cube_linear_sca_mpi.tex')

