close all
clc
clear all

np = 1:19;

%222.9
map = [0.04, 47.54, 21.84, 12.75, 8.53, 5.76, 4.23, 3.42, 2.6, 2.15, 1.97, 3.25, 4.48, 1.23, 1.05, 3.55, 0.78, 3.58, 3.35];
graph = [18.92, 12.99, 8.75, 7.55, 6.10, 5.03, 4.37, 3.94, 3.26, 3.03, 2.87, 3.95, 4.84, 2.24, 2.04, 3.81, 1.82, 4.01, 3.69];
assembly = [51.54, 25.83, 17.31, 14.68, 11.63, 9.56, 8.48, 7.13, 5.94, 5.59, 5.10, 5.98, 8.32, 4.05, 3.74, 5.23, 3.36, 6.46, 6.01];
export = [1.28, 1.09, 0.78, 0.64, 0.53, 0.45, 0.39, 0.35, 0.33, 0.29, 0.29, 0.35, 0.42, 0.23, 0.21, 0.2, 0.23, 0.35, 0.36];

assembly = assembly + export;
map = 0*map;
% 10 error


total = map+graph+assembly;

line_width = 1.5;
bar_width = 1;
figure
b1 = bar(np+0.5,map+graph+assembly,bar_width,'r','LineWidth',line_width);
hold on 
b2 = bar(np+0.5,graph+assembly,bar_width,'g','LineWidth',line_width);
b3 = bar(np+0.5,assembly,bar_width,'b','LineWidth',line_width);
xlabel('MPI process')
ylabel('Real CPU cost [sec]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,20])
legend([b1,b2,b3],'Map','Graph','Matrix')
%matlab2tikz('mpi_cube_real_CPU.tex')


figure
b1 = bar(np+0.5,(map+graph+assembly)./total,bar_width,'r','LineWidth',line_width);
hold on 
b2 = bar(np+0.5,(graph+assembly)./total,bar_width,'g','LineWidth',line_width);
b3 = bar(np+0.5,assembly./total,bar_width,'b','LineWidth',line_width);
xlabel('MPI process')
ylabel('Relative CPU cost [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,20])
legend([b1,b2,b3],'Map','Graph','Matrix', 'Location','SouthEast')
%matlab2tikz('mpi_cube_relative_CPU.tex')

% figure
% b1 = bar(np+0.5,(map+graph+assembly).*np,bar_width,'r','LineWidth',line_width);
% hold on 
% b2 = bar(np+0.5,(graph+assembly).*np,bar_width,'g','LineWidth',line_width);
% b3 = bar(np+0.5,(assembly).*np,bar_width,'b','LineWidth',line_width);
% xlabel('MPI process')
% ylabel('Used CPU cost [sec]')
% set(gca,'fontsize',18)
% grid on
% box on
% xlim([1,20])
% legend([b1,b2,b3],'Map','Graph','Matrix')
%matlab2tikz('mpi_cube_used_CPU.tex')

line_width = 2;

figure
p1 = plot(np,total(1)./total,'-bo',...
                'LineWidth',line_width,...
                'MarkerEdgeColor','b',...
                'MarkerFaceColor',[.49 1 .63],...
                'MarkerSize',10);
hold on
p2 = plot(np,np,'r--','LineWidth',line_width);
xlabel('MPI process')
ylabel('Speedup [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,19])
legend([p1,p2],'Actual','Ideal', 'Location','SouthEast')
%matlab2tikz('mpi_cube_speed_up.tex')

figure
p1 =plot(np,(total(1))./(total.*np),'-bo',...
                'LineWidth',line_width,...
                'MarkerEdgeColor','b',...
                'MarkerFaceColor',[.49 1 .63],...
                'MarkerSize',10);
hold on
p2 = plot([1,19],[1,1],'r--','LineWidth',line_width);
xlabel('MPI process')
ylabel('Efficiency [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,19])
legend([p1,p2],'Actual','Ideal', 'Location','SouthEast')
%matlab2tikz('mpi_cube_scalability.tex')

%%

figure
p1 = plot(np,assembly(1)./assembly,'-bo',...
                'LineWidth',line_width,...
                'MarkerEdgeColor','b',...
                'MarkerFaceColor',[.49 1 .63],...
                'MarkerSize',10);
hold on
p2 = plot(np,np,'r--','LineWidth',line_width);
xlabel('MPI process')
ylabel('Speedup [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,19])
legend([p1,p2],'Actual','Ideal', 'Location','SouthEast')
%matlab2tikz('mpi_cube_speed_up.tex')

figure
p1 =plot(np,(assembly(1))./(assembly.*np),'-bo',...
                'LineWidth',line_width,...
                'MarkerEdgeColor','b',...
                'MarkerFaceColor',[.49 1 .63],...
                'MarkerSize',10);
hold on
p2 = plot([1,19],[1,1],'r--','LineWidth',line_width);
xlabel('MPI process')
ylabel('Efficiency [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,19])
legend([p1,p2],'Actual','Ideal', 'Location','SouthEast')
%matlab2tikz('mpi_cube_scalability.tex')

%%

close all
clc
clear all

np = 12;

n_iter = linspace(1,200,200);

map = [0.1,2.];
graph = [75.4,6.8];
assembly = [140.3,11.7];

for i=1:length(n_iter)
    total(i,:) = map(:)+graph(:)+n_iter(i)*assembly(:);
end

line_width = 2;

figure
p1 = plot(n_iter,total(:,1)./total(:,2),'-b',...
                'LineWidth',line_width);
hold on
p2 = plot([1,max(n_iter)],[np,np],'r--','LineWidth',line_width);
p3 = plot([1,max(n_iter)],[assembly(1)/assembly(2),assembly(1)/assembly(2)],'g--','LineWidth',line_width);
xlabel('Number of linear iterations')
ylabel('Speedup [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,max(n_iter)])
ylim([10,12])
legend([p1,p2,p3],'Actual','Ideal','Theoretical limit', 'Location','SouthEast')
matlab2tikz('cube_linear_speed_mpi.tex')

figure
p1 =plot(n_iter,total(:,1)./(total(:,2)*np),'-b',...
                'LineWidth',line_width);
hold on
p2 = plot([1,max(n_iter)],[1,1],'r--','LineWidth',line_width);
p3 = plot([1,max(n_iter)],[assembly(1)/(np*assembly(2)),assembly(1)/(np*assembly(2))],'g--','LineWidth',line_width);
xlabel('Number of linear iterations')
ylabel('Efficiency [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,max(n_iter)])
ylim([0.8,1])
legend([p1,p2,p3],'Actual','Ideal','Theoretical limit', 'Location','SouthEast')
matlab2tikz('cube_linear_sca_mpi.tex')

