/*
 * Copyright 2020 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef WTDIRICHLET_H
#define WTDIRICHLET_H

#include "mirrors.h"
#include "wGroup.h"
#include <vector>
#include <string>

using namespace tbox;

namespace mirrors
{

/**
 * @brief manage thermal Dirichlet BC
 */

class MIRRORS_API TDirichlet : public Group
{
public:
    std::string BC_name;
    std::vector<Node *> nodes;
    double values;

    TDirichlet(Problem &pbl, int no, std::string _BC_name, double _values);
    TDirichlet(Problem &pbl, std::string const &name, std::string _BC_name, double _values);

#ifndef SWIG
    virtual void write(std::ostream &out) const override;
#endif
};

} // namespace mirrors

#endif //WTDIRICHLET_H
